%donald


# defines the content of the arrow boxes

viewport LEFT

openshape left_arrow
within left_arrow {
    point leftline,rightline,toparrow,bottomarrow
    line axis,top,bottom
}

within left_arrow {
    leftline = {0,20}
    rightline = {40,20}
    toparrow = {10,10}
    bottomarrow = {10,30}
}

within left_arrow {

axis = [leftline,rightline]
top = [toparrow,leftline]
bottom = [bottomarrow,leftline]
}

viewport RIGHT

openshape right_arrow
within right_arrow{
    point leftline,rightline,toparrow,bottomarrow
    line axis,top,bottom
}

within right_arrow{
    leftline = {0,20}
    rightline = {40,20}
    toparrow = {30,10}
    bottomarrow = {30,30}
}

within right_arrow{

axis = [leftline,rightline]
top = [toparrow,rightline]
bottom = [bottomarrow,rightline]
}


viewport UP

openshape up_arrow

within up_arrow{
    point leftline,rightline,toparrow,bottomarrow
    line axis,top,bottom
}

within up_arrow{
    leftline = {20,40}
    rightline = {20,0}
    toparrow = {10,10}
    bottomarrow = {30,10}
}

within up_arrow{

axis = [leftline,rightline]
top = [toparrow,rightline]
bottom = [bottomarrow,rightline]
}

viewport DOWN

openshape down_arrow

within down_arrow{
    point leftline,rightline,toparrow,bottomarrow
    line axis,top,bottom
}

within down_arrow{
    leftline = {20,40}
    rightline = {20,0}
    toparrow = {10,30}
    bottomarrow = {30,30}
}

within down_arrow{

axis = [leftline,rightline]
top = [toparrow,leftline]
bottom = [bottomarrow,leftline]
}

%scout

#defines the arrows

display scr;
window left,right,up,down;
point topleft, bottomright,rightoffset,upoffset,downoffset;
string window_type,background_color;

topleft = {20,80};
bottomright = {60,120};
background_color="white";
rightoffset = {80,0};
upoffset = {40,40};
downoffset = {40,-40};

left = {
	box:[topleft, bottomright],
	pict: "LEFT",
	type: DONALD,
	xmin: 0,
	xmax: 40,
	ymin: 0,
	ymax: 40,
	border: 1
	sensitive: ON
	bgcolor:background_color
	};

right = {
	box:[topleft + rightoffset, bottomright + rightoffset],
	pict: "RIGHT",
	type: DONALD,
	xmin: 0,
	xmax: 40,
	ymin: 0,
	ymax: 40,
	border: 1
	sensitive: ON
	bgcolor:background_color
	};

up = {
	box:[topleft + upoffset, bottomright + upoffset],
	pict: "UP",
	type: DONALD,
	xmin: 0,
	xmax: 40,
	ymin: 0,
	ymax: 40,
	border: 1
	sensitive: ON
	bgcolor:background_color
	};

down = {
	box:[topleft + downoffset, bottomright + downoffset],
	pict: "DOWN",
	type: DONALD,
	xmin: 0,
	xmax: 40,
	ymin: 0,
	ymax: 40,
	border: 1
	sensitive: ON
	bgcolor:background_color
	};



%donald

viewport PAD

openshape pad

within pad {

point interpoint0,currentpoint

interpoint0 = {100,100}

}


%scout

#defining the drawing pad

window pad;
point topleftpad, bottomrightpad;
integer input;
string background_color;

topleftpad = {200,20};
bottomrightpad = {400,220};
background_color="white";

pad = {
	box:[topleftpad, bottomrightpad],
	pict: "PAD",
	type: DONALD,
	xmin: 0,
	xmax:200,
	ymin: 0,
	ymax: 200,
	border: 1
	sensitive: ON
	bgcolor:background_color
	};

scr = < left/right/down/up/pad >; 
screen = scr;

%eden

increment = 5;

/* Mouse handling messages. */

proc handle_user_input : input
{
    switch(input) {
    case 1 :  add_new_line_etch((0-increment),0); break;
    case 2 :  add_new_line_etch(increment,0); break;
    case 3 :  add_new_line_etch(0,(0-increment)); break;
    case 4 :  add_new_line_etch(0,increment); break;
    }
}

proc left_click : left_mouse
{
    if(left_mouse[2]==4) 
        input = 1;
}

proc right_click : right_mouse
{
    if(right_mouse[2]==4) 
        input = 2;
}

proc up_click : up_mouse
{
    if(up_mouse[2]==4) 
        input = 3;
}

proc down_click : down_mouse
{
    if(down_mouse[2]==4) 
        input = 4;
}

%eden

counter=1;

/* This controls the drawing of the lines in donald based on 
   the vector(x,y) difference from the last known point */

proc add_new_line_etch
{
    para x,y;

    execute("%donald
    openshape pad
    within pad{
    point interpoint"//str(counter)//"
    interpoint"//str(counter)//" = interpoint"//str(counter-1)//"+ {"//str(x)//","//str(y)//"}
    line line"//str(counter)//"
    line"//str(counter)//" = [interpoint"//str(counter)//",interpoint"//str(counter-1)//"]
    }");

    counter = counter + 1;
}
